package de.szut.casino.slots;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.math.BigDecimal;

@Getter
@Setter
@AllArgsConstructor
public class Symbol {
    private String name;
    private BigDecimal payoutMultiplier;

    @Override
    public boolean equals(Object other) {
        if (!(other instanceof Symbol that)) {
            return false;
        }

        return this.name.equals(that.name) && this.payoutMultiplier.equals(that.payoutMultiplier);
    }

    @Override
    public int hashCode() {
        int hashCode = 1;

        hashCode = hashCode * 37 + this.name.hashCode();
        hashCode = hashCode * 37 + this.payoutMultiplier.hashCode();

        return hashCode;
    }
}
